<template lang="html">
  <v-card width="300" tile :loading="mining">
    <template slot="progress">
      <v-progress-linear
        height="10"
        v-model="blocksMined"
      ></v-progress-linear>
    </template>

    <v-card-title>
      Mine Blocks
    </v-card-title>
    <v-card-subtitle>
      Current Block {{ blockNumber }}
    </v-card-subtitle>
    <v-card-text>
      <v-row dense no-gutters>
        <v-col cols="6">
          <v-text-field v-model="blocks"></v-text-field>
        </v-col>
        <v-col cols="6">
          <v-btn @click="mine">
            Mine
          </v-btn>
        </v-col>
      </v-row>
    </v-card-text>
  </v-card>
</template>

<script>
import { ethers } from "ethers";
export default {
  name: "MineNBlocks",
  data() {
    return {
      mining: false,
      blocks: null,
      blocksMined: 0,
      blockNumber: 0,
      jsonRpcProvider: 0
    }
  },
  async created() {
     this.jsonRpcProvider = new ethers.providers.JsonRpcProvider();
     this.blockNumber = await this.jsonRpcProvider.getBlockNumber();
  },
  methods: {
    async mine() {
      this.blocksMined = 0;
      this.mining = true;

      for (let index = 0; index < parseInt(this.blocks); index++) {
        await this.jsonRpcProvider.send("evm_mine");
        this.blocksMined++;
      }

      this.mining = false;

      this.blockNumber = await this.jsonRpcProvider.getBlockNumber();
      this.blocks = null;
      this.blocksMined = 0;
    }
  }
}
</script>
